#version 330

uniform sampler2DRect inputTex;
uniform sampler2DRect inputTex1;
uniform float transitionProgress=1.0;
uniform float transitionProgressLinear=1.0;
uniform float transitionAlpha=1.0;
uniform int transitionState;
uniform float baseAlpha=1.0;
uniform sampler2DRect maskTex;
in vec2 fsMaskTexture;


in vec2 fsTexture;
in vec2 fsTexture2;
in vec2 fsTextureSize;
in vec2 fsDirection;
in vec2 fsFragScale;
in float fsMix;

out vec4 outColor;

uniform ivec2 squares=ivec2(10,10);
uniform float smoothness=1.0;

const vec2 center = vec2(0.5, 0.5);
const vec3 grayScale=vec3(0.2126,0.7152,0.0722);

void main()
{
	vec4 newColor = texture(inputTex1, fsTexture2);
	vec3 oldColor = texture(inputTex, fsTexture).rgb;
	float gray=dot(newColor.rgb,grayScale);
	
	vec2 uv0 = (fsTexture*2.0 - 1.0) * 0.5;
	float length0 = sqrt(dot(uv0, uv0));
	float time = transitionProgress * 25.0;
	float mask = 1.0 - clamp(length0 * 20.0 - (time*(gray*0.5+0.5)),0.0,1.0);
	
	// background
	vec3 bgimg = newColor.rgb;
	mask *= dot(vec3(1.0), vec3(1.0/3.0));
	
	// Output to screen
	outColor.rgb = (1.0-mask) * oldColor.rgb + mask*bgimg;
#ifdef USE_MASK
	outColor.a*=texture(maskTex,fsMaskTexture).a;
#endif
}
